Developer Documentation

Public Slots | Signals | Public Member Functions | Private Slots | Private Member Functions | Private Attributes | List of all members
TypeQtWidgetPlugin Class Reference
Inheritance diagram for TypeQtWidgetPlugin:

## Public Slots
QString | version ()

## Signals
void | emptyObjectAdded (int _id)
Signals inherited from BaseInterface
virtual void | updateView ()
| Update current view in Main Application. More...
virtual void | setSlotDescription (QString _slotName, QString _slotDescription, QStringList _parameters, QStringList _descriptions)
| Set a description for a public slot. More...
virtual void | setRenderer (unsigned int _viewer, QString _rendererName)
| Set a renderer for the given viewer. More...
Signals inherited from TypeInterface
virtual void | emptyObjectAdded (int _id)
| Emit this signal if an empty object has been created. More...
Signals inherited from LoadSaveInterface
virtual void | save (int _id, QString _filename)
| Save object to a file. More...
virtual void | load (QString _filename, DataType _type, int &_id)
| Load object from file with a specific DataType. More...

## Public Member Functions
QString | name ()
| Return a name for the plugin. More...
QString | description ()
| Return a description of what the plugin is doing. More...
bool | registerType ()
int | addEmpty ()
| Create an empty object. More...
DataType | supportedType ()
| Return your supported object type( e.g. DATA_TRIANGLE_MESH ) More...
void | slotMouseEvent (QMouseEvent *_event)
| Mouse Event from main application ( Picking Mode ) More...
void | objectDeleted (int _id)
| An object was deleted. More...

## Private Slots
void | noguiSupported ()
Private Slots inherited from BaseInterface
virtual void | exit ()
virtual QString | version ()
| Return a version string for your plugin. More...
Private Slots inherited from TypeInterface
virtual void | generateBackup (int _id, QString _name, UpdateType _type)
| This slot should be implemented in a TypePlugin to generate type specific backups. More...

## Private Member Functions
void | passMouseEvents (QMouseEvent *_event)
Private Member Functions inherited from BaseInterface
virtual void | noguiSupported ()
virtual | ~BaseInterface ()
| Destructor.
virtual void | blockScenegraphUpdates (bool _block)
| Tell the core to prevent scenegraph updates. More...
virtual void | updatedObject (int _objectId)
| An object has been changed or added by this plugin. More...
virtual void | updatedObject (int _identifier, const UpdateType &_type)
| An object has been changed or added by this plugin. More...
virtual void | nodeVisibilityChanged (int _identifier)
| A scenegraph node has been shown or hidden. More...
virtual void | getCurrentRenderer (unsigned int _viewer, QString &_rendererName)
| Get the current renderer for the given viewer. More...
Private Member Functions inherited from TypeInterface
virtual | ~TypeInterface ()
| Destructor.
Private Member Functions inherited from MouseInterface
virtual | ~MouseInterface ()
| Destructor.
Private Member Functions inherited from LoadSaveInterface
virtual | ~LoadSaveInterface ()
| Destructor.
virtual void | addEmptyObject (DataType _type, int &_id)
virtual void | copyObject (int _oldId, int &_newId)
virtual void | emptyObjectAdded (int _id)
| DEPRECATED HERE (Moved to Type Interface)! Emit this signal if an empty object has been created. More...
virtual void | deleteObject (int _id)
| Delete an object This signal can be called from any thread. . More...
virtual void | deleteAllObjects ()
| Delete all Objects. More...
virtual void | getAllFileFilters (QStringList &_filters)
| Get all file filters that are registered. More...

## Private Attributes
std::map< int, QtWidgetObject * > | widgets_

## Detailed Description

Definition at line 60 of file TypeQtWidget.hh.

## Member Function Documentation

## ◆ addEmpty()

int TypeQtWidgetPlugin::addEmpty | ( |  | ) |
| virtual

Create an empty object.

When this slot is called you have to create an object of your supported type.

Returns
  Id of the new Object

Implements TypeInterface.

Definition at line 61 of file TypeQtWidget.cc.

## ◆ description()

QString TypeQtWidgetPlugin::description | ( |  | ) |
| inline virtual

Return a description of what the plugin is doing.

This function has to return a basic description of the plugin

Implements BaseInterface.

Definition at line 88 of file TypeQtWidget.hh.

## ◆ name()

QString TypeQtWidgetPlugin::name | ( |  | ) |
| inline virtual

Return a name for the plugin.

This Function has to return the name of the plugin.

Implements BaseInterface.

Definition at line 87 of file TypeQtWidget.hh.

## ◆ objectDeleted()

void TypeQtWidgetPlugin::objectDeleted | ( | int | _id | ) |
| virtual

An object was deleted.

This function is called by the core if an object gets deleted. It is called immediately before the object is removed from the scenegraph. So if this function is invoked, the object still exists. All plugins get informed via this slot.\

After this function got called for all plugins, the object is removed from the scene with all nodes attached to it and all PerObjectData attached to it.
This slot will be executed on the main thread.

Parameters

  _id | Id of the object that is deleted.

Reimplemented from LoadSaveInterface.

Definition at line 92 of file TypeQtWidget.cc.

## ◆ slotMouseEvent()

void TypeQtWidgetPlugin::slotMouseEvent | ( | QMouseEvent * | _event | ) |
| virtual

Mouse Event from main application ( Picking Mode )

This slot is called if a mouse event occurred in the Viewer This slot will only get called in pickingMode. Right button clicks will not be passed to the plugins as this is reserved for the context Menu.

Parameters

  _event | Mouse event

Reimplemented from MouseInterface.

Definition at line 81 of file TypeQtWidget.cc.

## ◆ supportedType()

DataType TypeQtWidgetPlugin::supportedType | ( |  | ) |
| inline virtual

Return your supported object type( e.g. DATA_TRIANGLE_MESH )

The function is used from addEmpty in the core to check if your plugin can create an object of a given dataType. If so, your addEmpty function will be invoked to create it.

Implements TypeInterface.

Definition at line 99 of file TypeQtWidget.hh.

The documentation for this class was generated from the following files:

- Type-QtWidget/Plugin-TypeQtWidget/TypeQtWidget.hh
- Type-QtWidget/Plugin-TypeQtWidget/TypeQtWidget.cc